/**
 * Serial Duplex 
 * This is just a quick application for testing serial data
 * in both directions. 
 */

//Pour config la rasp lien ci dessous dans la partie 
//http://www.framboise314.fr/le-port-serie-du-raspberry-pi-3-pas-simple/

import processing.serial.*;

Serial myPort;      // The serial port
int whichKey = -1;  // Variable to hold keystoke values
int inByte = -1;    // Incoming serial data
int mode =0;
byte numero=0;
int poidsfortcapteur, poidsfaiblecapteur;
int[] val_capteur = {0, 0, 0, 0};
byte[] cons_lum ={0, 0, 0, 0, 0, 0, 0, 0};
int lum_globale=256;
int num_capteur;

int HPERSO = 511;

int[] registre1, registre2;
int indice;

int indexcapt1 = 0;
int indexcapt2 = 0;
int indexcapt3 = 0;
int indexcapt4 = 0;
int index_lect0 = 0;
int index_write0 = 0;
String portName = Serial.list()[0];

void setup() {
  size(513, 600);
  noStroke();
  // create a font with the third font available to the system:
  PFont myFont = createFont(PFont.list()[2], 14);
  textFont(myFont);

  // List all the available serial ports:
  println(Serial.list());

  // Ouvrir le port ttyAMA0
  // String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 38400); 
  println("mon port: " + portName + " ouvert");
  activate();

  registre1 = new int[42];
  registre2 = new int[42];
  indice = 0;
}

void draw() {
  // Pilotage d'actionneurs
  numero ++;
  if (numero > 4) {
    numero=0;
  }
  send_lum(numero); // à decommenter quand le test de base est fait
  //  myPort.write(0xB0); // entete midi
  //  myPort.write(1); // num est un byte
  //  myPort.write(val_capteur[1]/16); // cons_lum tableau de byte, renvoie les valeurs d'un capteur vers une lumiere.

  // Affichage des valeurs de capteurs
  fill(0, 0, 0);
  rect(1 + indexcapt1, 1, 2, HPERSO);
  
  fill(0, 255, 0);
  rect(0 + indexcapt1, 1, 2, val_capteur[0]/8);   
  
  fill(0, 0, 0);
  rect(128 + indexcapt2, 1, 2, HPERSO);
  
  fill(255, 0, 0);
  rect(127 + indexcapt2, 1, 2, val_capteur[1]/8);

  fill(0, 0, 0);
  rect(256 + indexcapt3, 1, 2, HPERSO);

  fill(0, 0, 255);
  rect(255 + indexcapt3, 1, 2, val_capteur[2]/8);

  fill(0, 0, 0);
  rect(256+128 + indexcapt4, 1, 2, HPERSO);

  fill(0, 255, 255);
  rect(255+128 + indexcapt4, 1, 2, val_capteur[3]/8);
}

void serialEvent(Serial myPort) {
  inByte = myPort.read();
  if (inByte > 127 )  
  { // l'octet recu est un entete comme un message midi
    switch (inByte&0xF0) // aiguillage selon l'ordre (on enleve le canal par le &)
    { 
    case 0xB0://type control change
      if ((inByte & 0x0F ) == 0)  // est-ce le canal 0 -> oui  c est pour nous
      {
        mode=1;
      } else  // ordre destiné à un autre module
      { 
        mode = 0;
      }
      break;
    default : //tous les autres messages midi 
      mode=0;
      break;
    }
  } else  // l'octet recu est une donnee
  {
    switch(mode)
    {
    case 0:
      mode = 0;
      break;
    case 1:    // cas du numero de ctrl change
      num_capteur= inByte/32 ; // valeur de capteur en 12 bits
      // ctl de 0 a 31 = capteur 0
      // ctl de 32 a 63 = capteur 1
      // ctl de 64 a 95 = capteur 2
      // ctl de 96 a 127 = capteur 3
      poidsfortcapteur = inByte&31; //plus performant que inByte%32
      mode =2+num_capteur; //on ira dans des cas différents selon le numéro de capteur
      break;
    case 2:     // cas capteur 0  
      poidsfaiblecapteur = inByte;
      val_capteur[0]=poidsfortcapteur*128+ poidsfaiblecapteur;
      mode=1;
      // on peut faire ici l analyse temps reel du capteur 0 si on veut
      indexcapt1++;
      indexcapt1 = indexcapt1 & 127;
      break;
    case 3:     // cas capteur 1  
      poidsfaiblecapteur = inByte;
      val_capteur[1]=poidsfortcapteur*128+ poidsfaiblecapteur;
      mode=1;
      //on peut faire ici l analyse temps reel du capteur 1 si on veut
      indexcapt2++;
      indexcapt2 = indexcapt2 & 127;
      break;
    case 4:     // cas capteur 2  
      poidsfaiblecapteur = inByte;
      val_capteur[2]=(poidsfortcapteur*128)+ poidsfaiblecapteur;
      mode=1;
      // on peut faire ici l analyse temps reel du capteur 2 si on veut
      println("capt2 " + val_capteur[2]);
      indexcapt3++;
      indexcapt3 = indexcapt3 & 127;
      break;
    case 5:     // cas capteur 3  
      poidsfaiblecapteur = inByte;
      val_capteur[3]=poidsfortcapteur*128+ poidsfaiblecapteur;
      mode=1;
      // on peut faire ici l analyse temps reel du capteur 3 si on veut
      indexcapt4++;
      indexcapt4 = indexcapt4 & 127;
      break;
    } // fin du switch(mode)
  } // fin du else // l'octet recu est une donnee
}

void send_lum(byte num) {
  if (num<4)
  { // toujours envoyer des bytes pour eviter tout souci
    myPort.write(0xB0); // entete midi
    myPort.write(num); // num est un byte
    myPort.write(cons_lum[num]); // cons_lum tableau de byte
  } else
  { // envoi de la luminosité globale toujours via des bytes
    byte numctl=byte(4+(lum_globale&3));
    byte valctl=byte(lum_globale/4);
    myPort.write(0xB0); // entete midi
    myPort.write(numctl); // num est un byte
    myPort.write(valctl); // cons_lum tableau de byte
  }
}
void verif_baudrate()
{
  myPort.write(0xFF);
}

// Test de fonctionnement par touches de clavier
void keyPressed() {
  switch(key)
  {
  case 's':
  case 'e':
    desactivate();
    myPort.clear();
    myPort.stop();
    println("mon port: " + portName + " ferme");
    println("exit programme");
    exit();
    break;
  case '7':   //incrementer couleur1
    if (cons_lum[0]<127) {
      cons_lum[0] ++;
    }
    println("couleur 1 :" + cons_lum[0]);
    break;
  case '1':   // decrementer couleur1
    if (cons_lum[0]>0) {
      cons_lum[0]--;
    }
    println("couleur 1 :" + cons_lum[0]);
    break;
  case '8':   //incrementer couleur2
    if (cons_lum[1]<127) {
      cons_lum[1]++;
    }
    println("couleur 2 :" + cons_lum[1]);
    break;
  case '2':   //decrementer couleur2
    if (cons_lum[1]>0) {
      cons_lum[1]--;
    }
    println("couleur 2 :" + cons_lum[1]);
    break;
  case '9':    //incrementer couleur3
    if (cons_lum[2]<127) {
      cons_lum[2]++;
    }
    println("couleur 3 :" + cons_lum[2]);
    break;
  case '3':    //decrementer couleur3
    if (cons_lum[2]>0) {
      cons_lum[2]--;
    }
    println("couleur 3 :" + cons_lum[2]);
    break;
  case '6':    //incrementer couleur4
    if (cons_lum[3]<127) {
      cons_lum[3]++;
    }
    println("couleur 4 :" + cons_lum[3]);
    break;
  case '4':    //decrementer couleur4
    if (cons_lum[3]>0) {
      cons_lum[3]--;
    }
    println("couleur 4 :" + cons_lum[3]);
    break;
  case '+':    // incrementer luminosite generale
    if (lum_globale<511) {
      lum_globale++;
    }
    println("lum globale :" + lum_globale);
    break;
  case '-':    // decrementer luminosite generale
    if (lum_globale>0) {
      lum_globale--;
    }
    println("lum globale :" + lum_globale);
    break;
  case '0': // tout eteint
    cons_lum[0]=0;
    cons_lum[1]=0;
    cons_lum[2]=0;   
    cons_lum[3]=0;
    lum_globale=0;
    break;
  case 'r': // premier actionneur allume
    cons_lum[0]=127;
    cons_lum[1]=0;
    cons_lum[2]=0;   
    cons_lum[3]=0;
    lum_globale=511;
    break;
  case 'b':
    cons_lum[0]=0;
    cons_lum[1]=127;
    cons_lum[2]=0;   
    cons_lum[3]=0;
    lum_globale=511;
    break;
  case 'g':
    cons_lum[0]=0;
    cons_lum[1]=0;
    cons_lum[2]=127;   
    cons_lum[3]=0;
    lum_globale=511;
    break;
  case 'y':
    cons_lum[0]=127;
    cons_lum[1]=0;
    cons_lum[2]=127;  
    cons_lum[3]=0;
    lum_globale=511;
    break;
  case 'm':
    cons_lum[0]=127;
    cons_lum[1]=127;
    cons_lum[2]=0;   
    cons_lum[3]=0;
    lum_globale=511;
    break;
  case 'c':
    cons_lum[0]=0;
    cons_lum[1]=127;
    cons_lum[2]=127;  
    cons_lum[3]=0;
    lum_globale=511;
    break;
  case 'w':
    cons_lum[0]=127;
    cons_lum[1]=127;
    cons_lum[2]=127;  
    cons_lum[3]=127;
    lum_globale=511;
    break;
  default:
    break;
  }
}

void activate() {
  myPort.write(0xB0); //entete midi
  myPort.write(127); // numero ctl 127
  myPort.write(127); // valeur 127   //ON
  println("active communication serie PIC");
}
void desactivate() {
  myPort.write(0xB0); //entete midi
  myPort.write(127); // numero ctl 127
  myPort.write(0); // valeur 0 //OFF
  println("desactive communication serie PIC");
}
